﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
//引入命名空间
using System.Linq.Expressions;
namespace Demo
{
    class Program
    {
        static void Main(string[] args)
        {
            Expression<Func<Person, bool>> lamda = d => d.Name == "123123";
            var e = (BinaryExpression)lamda.Body;
            string s = ((MemberExpression)e.Left).Member.Name + "=" + ((ConstantExpression)e.Right).Value;
            Console.WriteLine(s);
            Expression<Func<Person, bool>> lamda123 = d => d.Name == "123123"&&d.Age==123123;
            ExpressionHelper ex = new ExpressionHelper(lamda123);
            Console.WriteLine(ex.Sb);
            Console.Read();
        }
    }
    public static class Ex
    {
        public static string TransfromNodeType(this ExpressionType ex)
        {
            switch (ex)
            {
                case ExpressionType.Add:
                    return "+";
                case ExpressionType.Equal:
                    return "=";
                case ExpressionType.Multiply:
                    return "*";
                case ExpressionType.AndAlso:
                    return "and";
                default :return "";
            }
        }
    }
    public class ExpressionHelper
    {
        StringBuilder sb = new StringBuilder();

        public StringBuilder Sb
        {
            get { return sb; }
            set { sb = value; }
        }
        public ExpressionHelper(Expression<Func<Person, bool>> lamda)
        {
            Start(lamda.Body);
        }
        private void Start(Expression ex)
        {
            switch (ex.NodeType)
            {
                case ExpressionType.Constant:
                    Ex_Constant(ex);
                    break;
                case ExpressionType.MemberAccess:
                    Ex_Member(ex);
                    break;
                default: Ex_Binary(ex); break;

            }
        }

        private void Ex_Member(Expression ex)
        {
            var e = (MemberExpression)ex;
            sb.Append(e.Member.Name);
        }

        private void Ex_Binary(Expression ex)
        {
            var e = (BinaryExpression)ex;
            sb.Append("(");
            Start(e.Left);
            sb.Append(e.NodeType.TransfromNodeType());
            Start(e.Right);
            sb.Append(")");
           
        }
        private void Ex_Constant(Expression ex)
        {
            var e = (ConstantExpression)ex;
            if (e.Type==typeof(string))
            {
                sb.Append("'"+e.Value+"'");
            }
            else
            {
                sb.Append(e.Value);
            }
        }
    }
    public class Person
    {
        public string Name { get; set; }
        public int Age { get; set; }
        public string Address { get; set; }

    }
}
